//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using Hsrm.EdgeGateway.Contracts;
using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Hsrm.EdgeGateway.GatewayMonitoringService
{
    
    
    /// <summary>
    /// A class that exposes the IGatewayMonitoringService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class GatewayMonitoringServiceProvider : IFeatureProvider
    {
        
        private IGatewayMonitoringService _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(GatewayMonitoringServiceProvider).Assembly, "GatewayMonitoringService.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public GatewayMonitoringServiceProvider(IGatewayMonitoringService implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        private System.Exception ConvertListenToServerMessagesExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "serverPattern"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/gateway/GatewayMonitoringService/v1/Command/ListenToServerMessages/Param" +
                            "eter/ServerPattern", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterCommandWithIntermediates<ListenToServerMessagesRequestDto, GatewayMonitoringMessage, ListenToServerMessagesIntermediateDto>("ListenToServerMessages", ListenToServerMessages, ConvertListenToServerMessagesIntermediate, ConvertListenToServerMessagesExceptions);
        }
        
        private ListenToServerMessagesIntermediateDto ConvertListenToServerMessagesIntermediate(GatewayMonitoringMessage intermediate)
        {
            return new ListenToServerMessagesIntermediateDto(intermediate, _server);
        }
        
        /// <summary>
        /// Executes the Listen To Server Messages command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IIntermediateObservableCommand<GatewayMonitoringMessage> ListenToServerMessages(ListenToServerMessagesRequestDto request)
        {
            request.Validate();
            return _implementation.ListenToServerMessages(request.ServerPattern.TryExtract(_server, "org.silastandard/gateway/GatewayMonitoringService/v1/Command/ListenToServerMessages/Param" +
                        "eter/ServerPattern"));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/gateway/GatewayMonitoringService/v1/Command/ListenToServerMessages"))
            {
                return typeof(IGatewayMonitoringService).GetMethod("ListenToServerMessages");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}


